<template>
    <div class="b-form-tags form-control h-auto input-tag">
        <template v-if="items.length">
            <div
                v-for="(item, index) in items"
                :key="index"
                class="b-form-tag"
            >
                {{ item }}<button
                    type="button"
                    class="close b-form-tag-remove"
                    @click="removeItem(index)"
                >
                    ×
                </button>
            </div>
        </template>
        <div class="d-flex">
            <input
                v-model="value"
                type="text"
                :placeholder="item.placeholder"
                class="b-form-tags-input flex-grow-1 w-100 p-0 m-0 bg-transparent border-0"
                @input="checkInput"
            >
        </div>
        <small v-if="duplicate">Duplicate tag(s): {{ duplicate }}</small>
        <b-button
            v-if="!duplicate"
            variant="outline-secondary"
            :disabled="value.length < 6"
            class="btn b-form-tags-button py-0"
            @click="addItem"
        >
            Add
        </b-button>
    </div>
</template>

<script>
export default {
    props: ['item'],
    data() {
        return {
            value: '',
            items: [],
            duplicate: null,
        }
    },
    created() {
        window.addEventListener('keyup', this.handlerPressKey)
    },
    beforeUnmount() {
        window.removeEventListener('keyup', this.handlerPressKey)
    },
    methods: {
        handlerPressKey(e) {
            if(e.keyCode == 13) this.addItem()
        },
        addItem() {
            if(this.value.length > 5) {
                this.items.push(this.value)
                this.value = ''  
                this.updData()    
            }         
        },
        checkInput() {
            if(this.value.length > 1 && this.value[0] !== '+')  this.addPlus()
            if(this.items.includes(this.value)) this.duplicate = this.value
            else if(this.duplicate) this.duplicate = null
        },
        removeItem(index) {
            this.items.splice(index, 1)
            this.updData()
        },
        updData() {
            this.$emit('input', this.items)
        },
        addPlus() {
            const item = this.value
            if(item[0] !== '+') this.value = `+${item}`
        }
    }
    
}
</script>

<style scoped lang="scss">
.b-form-tags {
    position: relative;
    padding-right: 60px;
}
.btn {
    position: absolute;
    right: 10px;
    top: 10px;
}
.b-form-tag {
    font-size: 75%;
    font-weight: normal;
    height: 21px;
    line-height: 1.5;
    margin-right: 0.25rem;
    margin-bottom: 0.25rem;
    display: inline-flex;
    align-items: baseline;
    background-color: #007bff;
    color: #fff;
    padding: 0.25em 0.4em;
    white-space: nowrap;
    vertical-align: baseline;
    border-radius: 0.25rem;
    button {
        color: inherit;
        font-size: 125%;
        line-height: 1;
        float: none;
        margin-left: 0.25rem;
    }
}
input {
    min-width: 5rem;
    height: 21px;
}
small {
    display: block;
    margin-top: 0.25rem;
    color: #6c757d;
    font-size: 80%;
    font-weight: 400;
}
</style>
